# -*- coding: utf-8 -*-
from __future__ import unicode_literals

from django.db import models, migrations


class Migration(migrations.Migration):

    dependencies = [
    ]

    operations = [
        migrations.CreateModel(
            name='Bloc',
            fields=[
                ('id', models.AutoField(verbose_name='ID', serialize=False, auto_created=True, primary_key=True)),
                ('nom', models.CharField(max_length=20, null=True, blank=True)),
                ('color_preses', models.CharField(max_length=20, null=True, blank=True)),
                ('grau', models.CharField(max_length=20, null=True, blank=True)),
                ('n_punts', models.IntegerField()),
                ('descripcio', models.CharField(max_length=150, null=True, blank=True)),
            ],
        ),
        migrations.CreateModel(
            name='Encadena',
            fields=[
                ('id', models.AutoField(verbose_name='ID', serialize=False, auto_created=True, primary_key=True)),
                ('n_intents', models.IntegerField()),
                ('data_encadene', models.DateField(null=True, blank=True)),
                ('comentaris', models.CharField(max_length=150, null=True, blank=True)),
                ('bloc', models.ForeignKey(to='ranking.Bloc')),
            ],
        ),
        migrations.CreateModel(
            name='Soci',
            fields=[
                ('id', models.AutoField(verbose_name='ID', serialize=False, auto_created=True, primary_key=True)),
                ('nom', models.CharField(max_length=20, null=True, blank=True)),
                ('cognom', models.CharField(max_length=20, null=True, blank=True)),
                ('cognom2', models.CharField(max_length=20, null=True, blank=True)),
                ('email', models.CharField(max_length=20)),
                ('telefon', models.CharField(max_length=20, null=True, blank=True)),
                ('data_naixement', models.DateField(null=True, blank=True)),
                ('n_compte', models.CharField(max_length=50, null=True, blank=True)),
                ('data_inscripcio', models.DateField(null=True, blank=True)),
            ],
        ),
        migrations.CreateModel(
            name='Zona',
            fields=[
                ('id', models.AutoField(verbose_name='ID', serialize=False, auto_created=True, primary_key=True)),
                ('nom', models.CharField(max_length=20, null=True, blank=True)),
                ('ubicacio', models.CharField(max_length=20, null=True, blank=True)),
            ],
        ),
        migrations.AddField(
            model_name='encadena',
            name='soci',
            field=models.ForeignKey(to='ranking.Soci'),
        ),
        migrations.AddField(
            model_name='bloc',
            name='zona',
            field=models.ForeignKey(to='ranking.Zona'),
        ),
    ]
