from django.conf.urls import url

from . import views

urlpatterns = [
    # ranking urls
    url(r'^top/$', views.top, name='top'),  # not used by app
    url(r'^top/(?P<n>[0-9]{5})/$', views.top_n, name='top_n'),  # not used by app
    
    # soci urls
    url(r'^soci/$', views.soci, name='soci'),
    url(r'^soci/(?P<id_soci>[0-9]{5})/$', views.soci_n, name='soci_n'),   # not used by app
    url(r'^soci_pk/$', views.soci_pk, name='soci_pk'),
    url(r'^soci_sn/(?P<id_bloc>[0-9]{5})/$', views.soci_sn, name='soci_sn'),
    
    # bloc urls
    url(r'^bloc/$', views.bloc, name='bloc'),
    url(r'^bloc/(?P<id_bloc>[0-9]{5})/$', views.bloc_n, name='bloc_n'),   # not used by app
    url(r'^bloc_en/(?P<id_soci>[0-9]{5})/$', views.bloc_en, name='bloc_en'),
    url(r'^bloc_sn/(?P<id_soci>[0-9]{5})/$', views.bloc_sn, name='bloc_sn'),

    url(r'^comentaris/(?P<id_bloc>[0-9]{5})/$', views.comentaris, name='comentaris'),
    url(r'^encadena/$', views.encadena, name='encadena'),

    # favorits urls
    url(r'^favorits/(?P<id_soci>[0-9]{5})/$', views.favorits, name='favorits'),
    url(r'^add_favorits/$', views.add_favorits, name='add_favorits'),
    url(r'^del_favorits/$', views.del_favorits, name='del_favorits'),

    # upload profile urls
    url(r'^upload_image/(?P<id_soci>[0-9]{5})/$', views.upload_image, name='upload_image'),
    url(r'^upload_passwd/$', views.upload_passwd, name='upload_image')

]
