package ub.mywall;

import android.content.Context;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.methods.HttpRequestBase;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.params.BasicHttpParams;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.UnsupportedEncodingException;

public class AndroidNetworkUtility
{
    public static boolean isConnected(Context ctx)
    {
        ConnectivityManager connectivityManager =
                ( ConnectivityManager) ctx.getSystemService( ctx.CONNECTIVITY_SERVICE );

        NetworkInfo networkInfo = connectivityManager.getActiveNetworkInfo();

        if ( networkInfo != null && networkInfo.isConnected() )  return true;

        return false;

    }

    public static String getHttpResponse(HttpRequestBase request)
    {
        String result = null;
        InputStream inputStream = null;

        try {
            DefaultHttpClient httpClient = new DefaultHttpClient(new BasicHttpParams());
            HttpResponse httpResponse = httpClient.execute(request);

            int statusCode = httpResponse.getStatusLine().getStatusCode();
            String reason = httpResponse.getStatusLine().getReasonPhrase();
            StringBuilder sb = new StringBuilder();

            if (statusCode == 200) {
                HttpEntity entity = httpResponse.getEntity();
                inputStream = entity.getContent();

                BufferedReader bReader = new BufferedReader(
                        new InputStreamReader(inputStream, "UTF-8"), 8);

                String line = null;

                while ((line = bReader.readLine()) != null) {
                    sb.append(line);
                }

            } else {
                sb.append(reason);
            }

            result = sb.toString();

        } catch (UnsupportedEncodingException ex) {
            ex.printStackTrace();

        } catch (ClientProtocolException ex1) {
            ex1.printStackTrace();

        } catch (IOException ex2) {
            ex2.printStackTrace();

        } finally {

            try {
                inputStream.close();

            } catch (IOException e) {
                e.printStackTrace();
            }

        }

        return result;

    }

}
