package ub.mywall;

import android.app.Activity;
import android.content.Context;
import android.os.AsyncTask;
import android.util.Log;
import android.view.View;
import android.widget.ListView;
import android.widget.ProgressBar;

import java.util.ArrayList;

public class BlocEnAsyncTask extends AsyncTask< Object, Void, ArrayList<Bloc> >
{
    Activity callerActivity;

    private Context context;

    private String pk_soci;


    public BlocEnAsyncTask( Context context, String pk_soci )
    {
        this.context = context;
        this.pk_soci = pk_soci;

    }

    @Override
    protected ArrayList<Bloc> doInBackground( Object... params )
    {
        ArrayList<Bloc> blocList = null;

        callerActivity = ( Activity ) params[0];

        BlocEnService blocEnService = new BlocEnService( context, pk_soci );

        try {
            blocList = blocEnService.getBlocs();

        } catch ( RuntimeException e ) {
            Log.i( "BlocEnAsyncTask", "ArrayList<Bloc> doInBackground( Object... params ) - blocEnService.getBlocs() RuntimeException !" );

        }

        return blocList;

    }

    @Override
    protected void onPostExecute( ArrayList<Bloc> blocList )
    {
        ListView listView = ( ListView ) callerActivity.findViewById( R.id.blocsEnLV );

        // BUG: error en listView.getAdapter()
        try {
            listView.getAdapter();
        }

        catch ( Exception e ) {
            listView = ( ListView ) callerActivity.findViewById( R.id.blocsEnLV );
        }

        if ( listView.getAdapter() == null )
        {
            BlocArrayAdapter blocArrayAdapter = new BlocArrayAdapter( context, R.layout.listview_row_layout_blocs, blocList );
            listView.setAdapter(blocArrayAdapter);

        } else {
            ( ( BlocArrayAdapter ) listView.getAdapter() ).updateData(blocList);
        }

        ProgressBar progressBar = ( ProgressBar ) callerActivity.findViewById( R.id.progressBarEnBAT );
        progressBar.setVisibility( View.GONE );

    }
    
}
  
