package ub.mywall;

import android.content.Context;
import android.content.SharedPreferences;
import android.util.Log;

import com.google.gson.Gson;
import com.google.gson.reflect.TypeToken;

import org.apache.http.client.methods.HttpGet;

import java.util.ArrayList;

public class BlocEnService
{
    private String BLOC_WEB_SERVICE_URL;
    private String pk_soci;
    private String token;

    private Context context;

    public BlocEnService ( Context context, String pk_soci )
    {
        this.context = context;
        this.pk_soci = pk_soci;

        SharedPreferences mShared = context.getSharedPreferences("claus", Context.MODE_PRIVATE);
        this.token = mShared.getString( "token", null );

        String zeros = "";

        try {
            for ( int i = 0; i < 5 - pk_soci.length(); ++i ) { zeros = zeros +"0"; }

            BLOC_WEB_SERVICE_URL = "http://37.59.100.31:8080/ranking/bloc_sn/" +zeros + pk_soci +"/?format=json";

            Log.i ("BlocEnService", "URL to get: " +BLOC_WEB_SERVICE_URL);

        } catch ( RuntimeException e ) {
            BLOC_WEB_SERVICE_URL = "http://37.59.100.31:8080/ranking/bloc_sn/00000/?format=json";

        }
    }

    public ArrayList<Bloc> getBlocs()
    {
        ArrayList<Bloc> blocList = null;

        HttpGet httpGet = new HttpGet( BLOC_WEB_SERVICE_URL );
        httpGet.addHeader("Authorization","Token " +token);

        //setting header to request for a JSON response
        httpGet.setHeader( "Accept", "application/json" );
        AndroidNetworkUtility httpUtil = new AndroidNetworkUtility();

        String blocJSONStr = httpUtil.getHttpResponse( httpGet );

        blocList = convertJson( blocJSONStr );

        return blocList;
    }

    private ArrayList<Bloc> convertJson( String blocJSONStr )
    {
        ArrayList<Bloc> blocList = null;

        if ( blocJSONStr != null && blocJSONStr.length() > 0 )
        {
            try {
                Gson gson = new Gson();
                blocList =
                        gson.fromJson( blocJSONStr, new TypeToken<ArrayList<Bloc>>() {}.getType() );

            } catch (IllegalStateException e) {
                e.printStackTrace();
            }
        }

        return blocList;

    }
}
