package ub.mywall;

import android.content.Context;
import android.content.SharedPreferences;

import com.google.gson.Gson;
import com.google.gson.reflect.TypeToken;

import org.apache.http.client.methods.HttpGet;

import java.util.ArrayList;

public class BlocService
{
    private Context context;

    private static final String BLOC_WEB_SERVICE_URL = "http://37.59.100.31:8080/ranking/bloc/?format=json";

    public BlocService ( Context context )
    {
        this.context = context;

    }

    public ArrayList<Bloc> getBlocs()
    {
        ArrayList<Bloc> blocList = null;

        SharedPreferences mShared = context.getSharedPreferences("claus", Context.MODE_PRIVATE);
        String token = mShared.getString( "token", null );

        HttpGet httpGet = new HttpGet( BLOC_WEB_SERVICE_URL );
        httpGet.addHeader("Authorization","Token " +token);

        //setting header to request for a JSON response
        httpGet.setHeader( "Accept", "application/json" );
        AndroidNetworkUtility httpUtil = new AndroidNetworkUtility();

        String blocJSONStr = httpUtil.getHttpResponse( httpGet );

        blocList = convertJson( blocJSONStr );

        return blocList;
    }

    private ArrayList<Bloc> convertJson( String blocJSONStr )
    {
        ArrayList<Bloc> blocList = null;

        if ( blocJSONStr != null && blocJSONStr.length() > 0 )
        {
            try {
                Gson gson = new Gson();
                blocList =
                        gson.fromJson( blocJSONStr, new TypeToken<ArrayList<Bloc>>() {}.getType() );

            } catch (IllegalStateException e) {
                e.printStackTrace();
            }
        }

        return blocList;

    }
}
