package ub.mywall;

import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.TextView;

import java.util.ArrayList;
import java.util.List;

public class ComentarisArrayAdapter extends ArrayAdapter<Comentaris>
{
    private List<Comentaris> comentarisList;

    private Context context;

    public void updateData( ArrayList<Comentaris> comentarisList )
    {
        this.comentarisList = comentarisList;
        this.notifyDataSetChanged();
    }

    static class ComentarisViewHolder
    {
        TextView nom_soci;
        TextView cognom_soci;
        TextView comentaris;
        TextView data_encadene;

    }

    public ComentarisArrayAdapter( Context context, int textViewResourceId, ArrayList<Comentaris> comentarisList )
    {
        super( context, textViewResourceId );

        this.context = context;
        this.comentarisList = comentarisList;
    }

    @Override
    public int getCount() {
        return this.comentarisList.size();
    }

    @Override
    public Comentaris getItem ( int index ) {
        return this.comentarisList.get( index );
    }

    @Override
    public View getView( int position, View convertView, ViewGroup parent )
    {
        View row = convertView;
        ComentarisViewHolder viewHolder;

        final Comentaris comentari = getItem( position );

        if ( row == null )
        {
            LayoutInflater inflater = ( LayoutInflater ) this.getContext().getSystemService( Context.LAYOUT_INFLATER_SERVICE );

            row = inflater.inflate(R.layout.listview_row_layout_comentaris, parent, false);

            viewHolder = new ComentarisViewHolder();

            viewHolder.nom_soci = ( TextView ) row.findViewById( R.id.nom_soci );
            viewHolder.cognom_soci = ( TextView ) row.findViewById( R.id.cognom_soci );
            viewHolder.comentaris = ( TextView ) row.findViewById( R.id.comentaris);
            viewHolder.data_encadene = ( TextView ) row.findViewById( R.id.data_encadene);

            row.setTag(viewHolder);

        } else {
            viewHolder = (ComentarisViewHolder) row.getTag();
        }

        viewHolder.nom_soci.setText(comentari.getNom());
        viewHolder.cognom_soci.setText(comentari.getCognom());
        viewHolder.comentaris.setText(comentari.getComentaris());
        viewHolder.data_encadene.setText(comentari.getData_encadene());

        return row;

    }

    public Bitmap decodeToBitmap(byte[] decodedByte) {
        return BitmapFactory.decodeByteArray( decodedByte, 0, decodedByte.length );

    }

}