package ub.mywall;

import android.app.Activity;
import android.content.Context;
import android.os.AsyncTask;
import android.util.Log;
import android.view.View;
import android.widget.ListView;
import android.widget.ProgressBar;

import java.util.ArrayList;

public class ComentarisAsyncTask extends AsyncTask< Object, Void, ArrayList<Comentaris> >
{
    Activity callerActivity;

    private Context context;

    private String bloc_pk;

    public ComentarisAsyncTask( Context context, String bloc_pk )
    {
        this.context = context;
        this.bloc_pk = bloc_pk;

    }

    @Override
    protected ArrayList<Comentaris> doInBackground( Object... params )
    {
        ArrayList<Comentaris> comentarisList = null;

        callerActivity = ( Activity ) params[0];

        ComentarisService comentarisService = new ComentarisService( context, bloc_pk );

        try {
            comentarisList = comentarisService.getComentaris();

        } catch ( RuntimeException e ) {
            Log.i( "ComentarisAsyncTask", "ArrayList<Comentaris> doInBackground( Object... params ) - comentarisService.getComentaris() RuntimeException !" );

        }

        return comentarisList;

    }

    @Override
    protected void onPostExecute( ArrayList<Comentaris> comentarisList )
    {
        ListView listView = ( ListView ) callerActivity.findViewById( R.id.comentarisLV );

        if ( listView.getAdapter() == null )
        {
            ComentarisArrayAdapter comentarisArrayAdapter = new ComentarisArrayAdapter( context, R.layout.listview_row_layout_comentaris, comentarisList );
            listView.setAdapter( comentarisArrayAdapter );

        } else {
            ( ( ComentarisArrayAdapter ) listView.getAdapter() ).updateData(comentarisList);
        }

        ProgressBar progressBar = ( ProgressBar ) callerActivity.findViewById( R.id.progressBarComentaris );
        progressBar.setVisibility( View.GONE );

    }
    
}
  
