package ub.mywall;

import android.content.Context;
import android.content.SharedPreferences;
import android.util.Log;

import com.google.gson.Gson;
import com.google.gson.reflect.TypeToken;

import org.apache.http.client.methods.HttpGet;

import java.util.ArrayList;

public class ComentarisService
{
    private Context context;

    private String COMENTARIS_WEB_SERVICE_URL;
    private String bloc_pk;

    public ComentarisService( Context context, String bloc_pk )
    {
        this.context = context;
        this.bloc_pk = bloc_pk;

        String zeros = "";

        try {
            for ( int i = 0; i < 5 - bloc_pk.length(); ++i ) { zeros = zeros +"0"; }

            COMENTARIS_WEB_SERVICE_URL = "http://37.59.100.31:8080/ranking/comentaris/" +zeros + bloc_pk +"/?format=json";

            Log.i ("ComentarisService", "URL to get: " +COMENTARIS_WEB_SERVICE_URL);

        } catch ( RuntimeException e ) {
            COMENTARIS_WEB_SERVICE_URL = "http://37.59.100.31:8080/ranking/comentaris/00000/?format=json";

        }
    }

    public ArrayList<Comentaris> getComentaris()
    {
        ArrayList<Comentaris> comentarisList = null;

        SharedPreferences mShared = context.getSharedPreferences("claus", Context.MODE_PRIVATE);
        String token = mShared.getString( "token", null );

        HttpGet httpGet = new HttpGet( COMENTARIS_WEB_SERVICE_URL );
        httpGet.addHeader("Authorization","Token " +token);

        //setting header to request for a JSON response
        httpGet.setHeader( "Accept", "application/json" );
        AndroidNetworkUtility httpUtil = new AndroidNetworkUtility();

        String comentarisJSONStr = httpUtil.getHttpResponse( httpGet );

        comentarisList = convertJson( comentarisJSONStr );

        return comentarisList;
    }

    private ArrayList<Comentaris> convertJson( String comentarisJSONStr )
    {
        ArrayList<Comentaris> comentarisList = null;

        if ( comentarisJSONStr != null && comentarisJSONStr.length() > 0 )
        {
            try {
                Gson gson = new Gson();
                comentarisList =
                        gson.fromJson( comentarisJSONStr, new TypeToken<ArrayList<Comentaris>>() {}.getType() );

            } catch (IllegalStateException e) {
                e.printStackTrace();
            }
        }

        return comentarisList;

    }
}
