package ub.mywall;

import android.content.Context;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.TextView;

import java.util.ArrayList;
import java.util.List;

public class FavoritsArrayAdapter extends ArrayAdapter<Soci>
{
    private List<Soci> sociList;

    private Context context;

    public void updateData(ArrayList<Soci> sociList)
    {
        this.sociList = sociList;
        this.notifyDataSetChanged();
    }

    static class FavoritsViewHolder
    {
        TextView nom;
        TextView cognom;
        TextView puntuacio;
    }

    public FavoritsArrayAdapter( Context context, int textViewResourceId, ArrayList<Soci> sociList )
    {
        super( context, textViewResourceId );

        this.context = context;
        this.sociList = sociList;
    }

    @Override
    public int getCount()
    {
        if ( this.sociList != null )
            return this.sociList.size();

        else return 0;
    }

    @Override
    public Soci getItem ( int index )
    {
        return this.sociList.get( index );
    }

    @Override
    public View getView( int position, View convertView, ViewGroup parent )
    {
        View row = convertView;

        FavoritsViewHolder viewHolder;

        if ( row == null )
        {
            LayoutInflater inflater = ( LayoutInflater ) this.getContext().getSystemService( Context.LAYOUT_INFLATER_SERVICE );
            row = inflater.inflate(R.layout.listview_row_layout_favorits, parent, false);

            viewHolder = new FavoritsViewHolder();
            viewHolder.nom = ( TextView ) row.findViewById( R.id.nom );
            viewHolder.cognom = ( TextView ) row.findViewById( R.id.cognom );
            viewHolder.puntuacio = ( TextView ) row.findViewById( R.id.puntuacio );

            row.setTag(viewHolder);

        } else {
            viewHolder = ( FavoritsViewHolder ) row.getTag();
        }

        final Soci soci = getItem( position );

        viewHolder.nom.setText(soci.getNom());
        viewHolder.cognom.setText(soci.getCognom());
        viewHolder.puntuacio.setText(soci.getPuntuacio());

        row.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent i = new Intent(context, SociOnClick.class);

                // sending data to new activity
                i.putExtra("pk_soci", soci.getPk());
                i.putExtra("nom_soci", soci.getNom());
                i.putExtra("cognom_soci", soci.getCognom());
                i.putExtra("punts_soci", soci.getPuntuacio());

                context.startActivity(i);

            }
        });

        return row;

    }

    public Bitmap decodeToBitmap(byte[] decodedByte) {
        return BitmapFactory.decodeByteArray( decodedByte, 0, decodedByte.length );

    }

}