package ub.mywall;

import android.app.Activity;
import android.content.Context;
import android.os.AsyncTask;
import android.view.View;
import android.widget.ListView;
import android.widget.ProgressBar;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;

public class FavoritsAsyncTask extends AsyncTask< Object, Void, ArrayList<Soci> >
{
    Activity callerActivity;

    private Context mContext;

    @Override
    protected ArrayList<Soci> doInBackground( Object... params )
    {
        ArrayList<Soci> sociList = null;

        mContext = ( Context ) params[0];
        callerActivity = ( Activity ) params[0];

        FavoritsService favoritsService = new FavoritsService( mContext );
        sociList = favoritsService.getSocis();

        Collections.sort(sociList, new Comparator<Soci>() {
            @Override
            public int compare(Soci one, Soci other) {
                return Integer.parseInt(other.getPuntuacio()) - Integer.parseInt(one.getPuntuacio());
            }

        });

        return sociList;

    }

    @Override
    protected void onPostExecute( ArrayList<Soci> sociList )
    {
        ListView listView = ( ListView ) callerActivity.findViewById( R.id.favoritsLV );

        // BUG: error en listView.getAdapter()
        if ( listView != null )
        {
            if (listView.getAdapter() == null)
            {
                FavoritsArrayAdapter favoritsArrayAdapter = new FavoritsArrayAdapter(mContext, R.layout.listview_row_layout_favorits, sociList);
                listView.setAdapter( favoritsArrayAdapter );

            } else {
                ( (FavoritsArrayAdapter) listView.getAdapter() ).updateData(sociList);
            }

            ProgressBar progressBar = ( ProgressBar ) callerActivity.findViewById( R.id.progressBarFAT );
            progressBar.setVisibility( View.GONE );

        }
    }
}
  
