package ub.mywall;

import android.content.Context;
import android.content.SharedPreferences;
import android.util.Log;

import com.google.gson.Gson;
import com.google.gson.reflect.TypeToken;

import org.apache.http.client.methods.HttpGet;

import java.util.ArrayList;

public class FavoritsService
{
    private Context context;

    private String FAVORITS_WEB_SERVICE_URL;
    private String pk_soci;
    private String token;

    public FavoritsService( Context context )
    {
        this.context = context;

        SharedPreferences mShared = context.getSharedPreferences("claus", Context.MODE_PRIVATE);

        this.pk_soci = mShared.getString( "pk_soci", null );
        this.token = mShared.getString( "token", null );

        String zeros = "";

        try {
            for ( int i = 0; i < 5 - pk_soci.length(); ++i ) { zeros = zeros +"0"; }

            FAVORITS_WEB_SERVICE_URL = "http://37.59.100.31:8080/ranking/favorits/" +zeros + pk_soci +"/?format=json";

            Log.i("FavoritsService", "URL to get: " + FAVORITS_WEB_SERVICE_URL);

        } catch ( RuntimeException e ) {
            FAVORITS_WEB_SERVICE_URL = "http://37.59.100.31:8080/ranking/favorits/00000/?format=json";

        }
    }

    public ArrayList<Soci> getSocis()
    {
        ArrayList<Soci> sociList = null;

        HttpGet httpGet = new HttpGet( FAVORITS_WEB_SERVICE_URL );
        httpGet.addHeader("Authorization","Token " +token);

        //setting header to request for a JSON response
        httpGet.setHeader( "Accept", "application/json" );
        AndroidNetworkUtility httpUtil = new AndroidNetworkUtility();

        String sociJSONStr = httpUtil.getHttpResponse( httpGet );

        sociList = convertJson( sociJSONStr );

        return sociList;
    }

    private ArrayList<Soci> convertJson( String sociJSONStr )
    {
        ArrayList<Soci> sociList = null;

        if ( sociJSONStr != null && sociJSONStr.length() > 0 )
        {
            try {
                Gson gson = new Gson();
                sociList =
                        gson.fromJson( sociJSONStr, new TypeToken<ArrayList<Soci>>() {}.getType() );

            } catch (IllegalStateException e) {
                e.printStackTrace();
            }
        }

        return sociList;

    }
}
