package ub.mywall;

import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.AsyncTask;
import android.widget.ImageView;

import java.io.IOException;
import java.lang.ref.WeakReference;
import java.net.MalformedURLException;
import java.net.URL;

/**
 * Created by voriol on 16/12/15.
 */
public class ImageAsyncTask extends AsyncTask<String,Void,Bitmap>
{
    private WeakReference<ImageView> imageViewReference;

    private String url_image;

    public ImageAsyncTask ( ImageView imageView, String url_image )
    {
        this.imageViewReference = new WeakReference<>( imageView );
        this.url_image = url_image;
    }

    @Override
    protected Bitmap doInBackground( String... params )
    {
        String url = url_image;
        URL imageUrl = null;

        try {
            imageUrl = new URL( url );

        } catch ( MalformedURLException e ) {
            e.printStackTrace();
        }

        try {
            return BitmapFactory.decodeStream( imageUrl.openConnection().getInputStream() );

        } catch ( IOException e ) {
            e.printStackTrace();
        }

        return null;
    }

    @Override
    protected void onPostExecute( Bitmap bitmap )
    {
        if ( imageViewReference != null && bitmap != null )
        {
            final ImageView imageView = imageViewReference.get();

            if (  imageView != null )
            {
                imageView.setImageBitmap( bitmap );

            }
        }
    }
}