package ub.mywall;

import org.apache.http.NameValuePair;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.message.BasicNameValuePair;

import java.io.UnsupportedEncodingException;
import java.util.ArrayList;

public class LoginService
{
    private static String LOGIN_WEB_SERVICE_URL = "http://37.59.100.31:8080/api-token-auth/";
    private static String PK_WEB_SERVICE_URL = "http://37.59.100.31:8080/ranking/soci_pk/";

    private String username;
    private String password;

    public LoginService( String username, String password )
    {
        this.username = username;
        this.password = password;
    }

    public String[] getCredentials()
    {
        ArrayList<NameValuePair> nameValuePairs = new ArrayList<NameValuePair>();

        HttpPost httpPost = new HttpPost( LOGIN_WEB_SERVICE_URL );

        nameValuePairs.add( new BasicNameValuePair( "username", username ) );
        nameValuePairs.add( new BasicNameValuePair( "password", password ) );

        try
        {
            httpPost.setEntity( new UrlEncodedFormEntity( nameValuePairs ) );

        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }

        AndroidNetworkUtility httpUtil = new AndroidNetworkUtility();

        String tokenJSONStr = httpUtil.getHttpResponse( httpPost );

        String[] CREDENTIALS = convertJson( tokenJSONStr );

        return CREDENTIALS;

    }

    public String[] getPk( String token )
    {
        ArrayList<NameValuePair> nameValuePairs = new ArrayList<NameValuePair>();

        HttpGet httpGet = new HttpGet( PK_WEB_SERVICE_URL );
        httpGet.addHeader("Authorization","Token " +token);

        AndroidNetworkUtility httpUtil = new AndroidNetworkUtility();

        String pkJSONStr = httpUtil.getHttpResponse( httpGet );

        String[] PK = convertJson( pkJSONStr );

        return PK;

    }

    private String[] convertJson( String blocJSONStr )
    {
        String[] CREDENTIALS = new String[] {};

        blocJSONStr = blocJSONStr.replace( "[","" );
        blocJSONStr = blocJSONStr.replace( "]","" );
        blocJSONStr = blocJSONStr.replace( "{","" );
        blocJSONStr = blocJSONStr.replace( "}","" );

        blocJSONStr = blocJSONStr.replaceAll( "[\\x22]","" );

        CREDENTIALS = ( blocJSONStr.split( "," ) );

        return CREDENTIALS;

    }
}
