package ub.mywall;

import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.database.Cursor;
import android.graphics.Bitmap;
import android.net.Uri;
import android.os.Bundle;
import android.os.NetworkOnMainThreadException;
import android.preference.Preference;
import android.preference.PreferenceActivity;
import android.provider.MediaStore;
import android.util.Base64;

import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;

public class Perfil extends PreferenceActivity
{
    private static final int SELECT_PICTURE = 1;

    @Override
    protected void onCreate( Bundle savedInstanceState )
    {
        super.onCreate( savedInstanceState );
        addPreferencesFromResource( R.layout.activity_perfil );

        Preference filePicker = ( Preference ) findPreference( "pref_key_update_image" );

        filePicker.setOnPreferenceClickListener( new Preference.OnPreferenceClickListener()
        {
            @Override
            public boolean onPreferenceClick( Preference preference )
            {
                Intent intent = new Intent();

                intent.setType( "image/*" );
                intent.setAction( Intent.ACTION_GET_CONTENT );

                startActivityForResult( Intent.createChooser( intent, "Select Picture" ), SELECT_PICTURE );

                return true;
            }
        });

    }

    @Override
    public void onActivityResult( int requestCode, int resultCode, Intent data )
    {
        if ( resultCode == RESULT_OK )
        {
            if ( requestCode == SELECT_PICTURE )
            {
                Uri selectedImageUri = data.getData();

                uploadImage( selectedImageUri );

            }
        }
    }

    private void uploadImage( Uri selectedImageUri )
    {
        Bitmap bitmap = null;

        try {
            bitmap = MediaStore.Images.Media.getBitmap( this.getContentResolver(), selectedImageUri );

        } catch (IOException e) {
            e.printStackTrace();
        }

        ByteArrayOutputStream stream = new ByteArrayOutputStream();

        byte[] byte_arr = stream.toByteArray();

        bitmap.compress( Bitmap.CompressFormat.PNG, 90, stream );

        String image_str = Base64.encodeToString( byte_arr, Base64.DEFAULT );

        ArrayList<NameValuePair> nameValuePairs = new ArrayList<NameValuePair>();
        nameValuePairs.add(new BasicNameValuePair("image", image_str));

        HttpClient httpclient = new DefaultHttpClient();

        SharedPreferences mShared = this.getSharedPreferences("claus", Context.MODE_PRIVATE);
        String token = mShared.getString( "token", null );

        HttpPost httppost = new HttpPost( "http://37.59.100.31:8080/ranking" );
        httppost.addHeader("Authorization","Token " +token);

        try {
            httppost.setEntity ( new UrlEncodedFormEntity( nameValuePairs ) );
            HttpResponse response = httpclient.execute( httppost );

        } catch ( UnsupportedEncodingException e ) {
            e.printStackTrace();

        } catch ( ClientProtocolException e ) {
            e.printStackTrace();

        } catch ( IOException e ) {
            e.printStackTrace();

        } catch ( NetworkOnMainThreadException e ) {
            e.printStackTrace();
        }

    }

    /**
     * helper to retrieve the path of an image URI
     */
    public String getPath( Uri uri )
    {
        if ( uri == null ) return null;

        // try to retrieve the image from the media store first
        // this will only work for images selected from gallery
        String[] projection = { MediaStore.Images.Media.DATA };

        Cursor cursor = managedQuery( uri, projection, null, null, null );

        if ( cursor != null )
        {
            int column_index = cursor.getColumnIndexOrThrow( MediaStore.Images.Media.DATA );

            cursor.moveToFirst();

            return cursor.getString( column_index );

        }

        // this is our fallback here
        return uri.getPath();

    }

}
