package ub.mywall;

import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.TextView;

import java.util.ArrayList;
import java.util.List;

public class SociArrayAdapter extends ArrayAdapter<Soci>
{
    private List<Soci> sociList;

    private Context context;

    private String activity;

    public void updateData(ArrayList<Soci> sociList)
    {
        this.sociList = sociList;
        this.notifyDataSetChanged();
    }

    static class SociViewHolder
    {
        TextView nom;
        TextView cognom;
        TextView puntuacio;
        TextView posicio;

    }

    public SociArrayAdapter ( Context context, int textViewResourceId, ArrayList<Soci> sociList, String activity )
    {
        super( context, textViewResourceId );

        this.context = context;
        this.sociList = sociList;
        this.activity = activity;
    }

    @Override
    public int getCount()
    {
        if ( this.sociList != null )
            return this.sociList.size();

        else return 0;
    }

    @Override
    public Soci getItem ( int index ) {
        return this.sociList.get( index );
    }

    @Override
    public View getView( int position, View convertView, ViewGroup parent )
    {
        View row = convertView;
        SociViewHolder viewHolder;

        if ( row == null )
        {
            LayoutInflater inflater = ( LayoutInflater ) this.getContext().getSystemService( Context.LAYOUT_INFLATER_SERVICE );
            row = inflater.inflate(R.layout.listview_row_layout_socis, parent, false);

            viewHolder = new SociViewHolder();

            viewHolder.posicio = ( TextView ) row.findViewById( R.id.posicio );
            viewHolder.nom = ( TextView ) row.findViewById( R.id.nom );
            viewHolder.cognom = ( TextView ) row.findViewById( R.id.cognom );
            viewHolder.puntuacio = ( TextView ) row.findViewById( R.id.puntuacio );

            row.setTag(viewHolder);

        } else {
            viewHolder = ( SociViewHolder ) row.getTag();
        }

        final Soci soci = getItem( position );

        if ( activity.equals( "SociAsyncTask" ) )
        {
            String pos_soci = String.valueOf( position +1 );

            SharedPreferences mShared = context.getSharedPreferences( "claus", Context.MODE_PRIVATE );
            SharedPreferences.Editor mEditor = mShared.edit();

            mEditor.putString( "pos_soci", pos_soci ).apply();
            mEditor.commit();

            viewHolder.posicio.setVisibility( View.VISIBLE );
            viewHolder.posicio.setText( pos_soci );
        }

        viewHolder.nom.setText( soci.getNom() );
        viewHolder.cognom.setText( soci.getCognom() );
        viewHolder.puntuacio.setText( soci.getPuntuacio() );

        row.setOnClickListener( new View.OnClickListener()
        {
            @Override
            public void onClick( View v )
            {
                Intent i = new Intent( context, SociOnClick.class );

                // sending data to new activity
                i.putExtra( "pk_soci", soci.getPk() );
                i.putExtra( "nom_soci", soci.getNom() );
                i.putExtra( "cognom_soci", soci.getCognom() );
                i.putExtra( "img_perfil", soci.getImg_perfil() );
                i.putExtra( "punts_soci", soci.getPuntuacio() );

                context.startActivity(i);

            }
        });

        return row;

    }

    public Bitmap decodeToBitmap(byte[] decodedByte) {
        return BitmapFactory.decodeByteArray( decodedByte, 0, decodedByte.length );

    }

}