package ub.mywall;

import android.app.Activity;
import android.content.Context;
import android.os.AsyncTask;
import android.view.View;
import android.widget.ListView;
import android.widget.ProgressBar;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;

public class SociAsyncTask extends AsyncTask< Object, Void, ArrayList<Soci> >
{
    Activity callerActivity;

    private Context mContext;

    @Override
    protected ArrayList<Soci> doInBackground( Object... params )
    {
        ArrayList<Soci> sociList = null;

        mContext = ( Context ) params[0];
        callerActivity = ( Activity ) params[0];

        SociService sociService = new SociService( mContext );
        sociList = sociService.getSocis();

        Collections.sort(sociList, new Comparator<Soci>() {
            @Override
            public int compare(Soci one, Soci other) {
                return Integer.parseInt(other.getPuntuacio()) - Integer.parseInt(one.getPuntuacio());
            }

        });

        return sociList;

    }

    @Override
    protected void onPostExecute( ArrayList<Soci> sociList )
    {
        ListView listView = ( ListView ) callerActivity.findViewById( R.id.socisLV );

        // BUG: error en listView.getAdapter()
        if ( listView != null )
        {
            if (listView.getAdapter() == null)
            {
                SociArrayAdapter sociArrayAdapter = new SociArrayAdapter(mContext, R.layout.listview_row_layout_socis, sociList, "SociAsyncTask");
                listView.setAdapter(sociArrayAdapter);

            } else {
                ( (SociArrayAdapter) listView.getAdapter() ).updateData(sociList);
            }

            ProgressBar progressBar = ( ProgressBar ) callerActivity.findViewById( R.id.progressBarSAT );
            progressBar.setVisibility( View.GONE );

        }
    }
}
  
