package ub.mywall;

import android.app.Activity;
import android.content.Context;
import android.os.AsyncTask;
import android.util.Log;
import android.view.View;
import android.widget.ListView;
import android.widget.ProgressBar;

import java.util.ArrayList;

public class SociEnAsyncTask extends AsyncTask< Object, Void, ArrayList<Soci> >
{
    Activity callerActivity;

    private Context context;

    private String pk_bloc;

    public SociEnAsyncTask( Context context, String pk_bloc )
    {
        this.context = context;
        this.pk_bloc = pk_bloc;

    }

    @Override
    protected ArrayList<Soci> doInBackground( Object... params )
    {
        ArrayList<Soci> sociList = null;

        context = ( Context ) params[0];
        callerActivity = ( Activity ) params[0];

        SociEnService sociEnService = new SociEnService( context, pk_bloc );

        try {
            sociList = sociEnService.getSocis();

        } catch ( RuntimeException e ) {
            Log.i( "SociEnAsyncTask", "ArrayList<Soci> doInBackground( Object... params ) - sociEnService.getSocis() RuntimeException !" );

        }

        return sociList;

    }

    @Override
    protected void onPostExecute( ArrayList<Soci> sociList )
    {
        ListView listView = ( ListView ) callerActivity.findViewById( R.id.socisEnLV );

        // BUG: error en listView.getAdapter()
        try {
            listView.getAdapter();
        }

        catch ( Exception e ) {
            listView = ( ListView ) callerActivity.findViewById( R.id.socisEnLV );
        }

        if ( listView.getAdapter() == null )
        {
            SociArrayAdapter sociArrayAdapter = new SociArrayAdapter( context, R.layout.listview_row_layout_socis, sociList, "SociEnAsyncTask" );
            listView.setAdapter(sociArrayAdapter);

        } else {
            ( ( SociArrayAdapter ) listView.getAdapter() ).updateData(sociList);
        }

        ProgressBar progressBar = ( ProgressBar ) callerActivity.findViewById( R.id.progressBarEnSAT );
        progressBar.setVisibility( View.GONE );

    }
    
}
  
