package ub.mywall;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.graphics.Bitmap;
import android.graphics.Color;
import android.os.AsyncTask;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.ImageView;
import android.widget.TextView;

import org.apache.http.HttpResponse;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.DefaultHttpClient;
import org.json.JSONArray;
import org.json.JSONObject;

import java.io.InputStream;
import java.util.ArrayList;
import java.util.List;
import java.util.Vector;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.TimeoutException;


public class SociOnClick extends Activity
{
    private ImageAsyncTask IAT;
    private static Bitmap bmp;

    private ImageView ivFavorits;
    private boolean es_favorit;

    private String pk_soci;
    private String token;
    private String pk;

    private Activity activity;

    @Override
    public void onCreate( Bundle savedInstanceState )
    {
        super.onCreate(savedInstanceState);

        this.setContentView( R.layout.activity_soci );

        SharedPreferences mShared = this.getSharedPreferences("claus", Context.MODE_PRIVATE);

        pk_soci = mShared.getString( "pk_soci", null );
        token = mShared.getString( "token", null );

        Intent i = getIntent();

        // getting attached intent data
        pk = i.getStringExtra( "pk_soci" );

        String nom_soci = i.getStringExtra( "nom_soci" );
        String cognom_soci = i.getStringExtra( "cognom_soci" );
        String img_perfil = i.getStringExtra( "img_perfil" );
        String punts_soci = i.getStringExtra( "punts_soci" );

        ivFavorits = ( ImageView ) findViewById( R.id.favorits );

        // determinem si el usuari seleccionat es un usuari favorit
        ivFavorits.setOnClickListener( new View.OnClickListener()
        {
            public void onClick( View v )
            {
                if ( ! es_favorit)
                {
                    ivFavorits.setColorFilter( Color.RED );
                    new addFavoritAsyncTask().execute( "http://37.59.100.31:8080/ranking/add_favorits/" );

                    es_favorit = true;
                }

                else {
                    ivFavorits.setColorFilter( Color.TRANSPARENT );
                    new delFavoritAsyncTask().execute("http://37.59.100.31:8080/ranking/del_favorits/");

                    es_favorit = false;
                }
            }
        });

        ImageView ivImage = ( ImageView ) findViewById( R.id.soci_image );

        TextView txtNomSoci = ( TextView ) findViewById( R.id.soci_nom );
        TextView txtCognomSoci = ( TextView ) findViewById( R.id.soci_cognom );
        TextView txtPuntsSoci = ( TextView ) findViewById( R.id.soci_punts );

        if ( img_perfil != null )
        {
            String url_img_perfil = "http://37.59.100.31:8080" +img_perfil;

            IAT = new ImageAsyncTask( ivImage, url_img_perfil );
            IAT.execute();
        }

        // displaying selected soci name, surname and points
        txtNomSoci.setText( nom_soci );
        txtCognomSoci.setText(cognom_soci);
        txtPuntsSoci.setText( punts_soci );

    }

    private class addFavoritAsyncTask extends AsyncTask<String, Void, String>
    {
        @Override
        protected String doInBackground( String... urls )
        {
            addFavoritPOST( urls[0] );

            return "EncadenaAsyncTask DONE !";

        }

        // onPostExecute displays the results of the AsyncTask.
        @Override
        protected void onPostExecute(String result)
        {
            onResume();
        }

    }

    public void addFavoritPOST ( String url )
    {
        InputStream inputStream = null;
        String result = "";

        try
        {
            // create HttpClient
            HttpClient httpclient = new DefaultHttpClient();

            // make POST request to the given URL
            HttpPost httpPost = new HttpPost( url );
            httpPost.addHeader("Authorization","Token " +token);

            JSONArray pk_favorit = new JSONArray();
            pk_favorit.put( pk );

            // build jsonObject
            JSONObject jsonObject = new JSONObject();

            jsonObject.put( "soci", pk_soci );
            jsonObject.put( "favorits", pk_favorit );

            String json = jsonObject.toString();

            // set json to StringEntity
            StringEntity se = new StringEntity( json );

            // set httpPost Entity
            httpPost.setEntity( se );

            // set some headers to inform server about the type of the content
            httpPost.setHeader("Accept", "application/json");
            httpPost.setHeader("Content-type", "application/json");

            // execute POST request to the given URL
            HttpResponse httpResponse = httpclient.execute( httpPost );

            // receive response as inputStream
            inputStream = httpResponse.getEntity().getContent();

            if( inputStream != null )
                Log.d( "SociOnClick", "POST - inputStream OK !" );

            else
                Log.e( "SociOnClick", "POST - inputStream is null" );

        } catch ( Exception e ) {
            Log.d( "SociOnClick", "POST - error sending encadena json" );

        }

    }

    private class delFavoritAsyncTask extends AsyncTask<String, Void, String>
    {
        @Override
        protected String doInBackground( String... urls )
        {
            delFavoritPOST( urls[0] );

            return "EncadenaAsyncTask DONE !";

        }

        // onPostExecute displays the results of the AsyncTask.
        @Override
        protected void onPostExecute(String result)
        {
            onResume();
        }

    }

    public void delFavoritPOST ( String url )
    {
        InputStream inputStream = null;
        String result = "";

        try
        {
            // create HttpClient
            HttpClient httpclient = new DefaultHttpClient();

            // make POST request to the given URL
            HttpPost httpPost = new HttpPost( url );
            httpPost.addHeader("Authorization", "Token " + token);

            JSONArray pk_favorit = new JSONArray();
            pk_favorit.put( pk );

            // build jsonObject
            JSONObject jsonObject = new JSONObject();

            jsonObject.put( "soci", pk_soci );
            jsonObject.put( "favorits", pk_favorit );

            String json = jsonObject.toString();

            // set json to StringEntity
            StringEntity se = new StringEntity( json );

            // set httpPost Entity
            httpPost.setEntity( se );

            // set some headers to inform server about the type of the content
            httpPost.setHeader("Accept", "application/json");
            httpPost.setHeader("Content-type", "application/json");

            // execute POST request to the given URL
            HttpResponse httpResponse = httpclient.execute( httpPost );

            // receive response as inputStream
            inputStream = httpResponse.getEntity().getContent();

            if( inputStream != null )
                Log.d("SociOnClick", "POST - inputStream OK !");

            else
                Log.e("SociOnClick", "POST - inputStream is null" );

        } catch ( Exception e ) {
            Log.d( "SociOnClick", "POST - error sending encadena json" );

        }

    }

    private void esFavorit()
    {
        es_favorit = false;

        ArrayList<Soci> sociList = null;

        IsFavoritsAsyncTask isFavoritsAsyncTask = new IsFavoritsAsyncTask( this );

        isFavoritsAsyncTask.execute( activity );

        try {
            isFavoritsAsyncTask.get( 3000, TimeUnit.MILLISECONDS );

        } catch (InterruptedException e) {
            e.printStackTrace();

        } catch (ExecutionException e) {
            e.printStackTrace();

        } catch (TimeoutException e) {
            e.printStackTrace();
        }

        sociList = isFavoritsAsyncTask.getSociList();

        if ( sociList != null )
        {
            for ( Soci s : sociList )
            {
                if ( s.getPk().equals( pk ) )
                {
                    es_favorit = true;
                    break;
                }

            }

        }

        if ( es_favorit )
            ivFavorits.setColorFilter( Color.RED );

        else
            ivFavorits.setColorFilter( Color.TRANSPARENT );

        ivFavorits.setVisibility( View.VISIBLE );

    }

    @Override
    protected void onResume()
    {
        super.onResume();

        if ( AndroidNetworkUtility.isConnected( this ) )
        {
            if ( ! pk.equals( pk_soci ) ) esFavorit();

            new BlocEnAsyncTask( this, pk ).execute( this );

        }
    }

}
