package ub.mywall;

import android.content.Context;
import android.content.SharedPreferences;

import com.google.gson.Gson;
import com.google.gson.reflect.TypeToken;

import org.apache.http.client.methods.HttpGet;

import java.util.ArrayList;

public class SociService
{
    private Context context;

    private static final String SOCI_WEB_SERVICE_URL = "http://37.59.100.31:8080/ranking/soci/?format=json";
    
    public SociService ( Context context )
    {
        this.context = context;

    }

    public ArrayList<Soci> getSocis()
    {
        ArrayList<Soci> sociList = null;

        SharedPreferences mShared = context.getSharedPreferences("claus", Context.MODE_PRIVATE);
        String token = mShared.getString( "token", null );

        HttpGet httpGet = new HttpGet( SOCI_WEB_SERVICE_URL );
        httpGet.addHeader("Authorization","Token " +token);

        //setting header to request for a JSON response
        httpGet.setHeader( "Accept", "application/json" );
        AndroidNetworkUtility httpUtil = new AndroidNetworkUtility();

        String sociJSONStr = httpUtil.getHttpResponse( httpGet );

        sociList = convertJson( sociJSONStr );

        return sociList;
    }

    private ArrayList<Soci> convertJson( String sociJSONStr )
    {
        ArrayList<Soci> sociList = null;

        if ( sociJSONStr != null && sociJSONStr.length() > 0 )
        {
            try {
                Gson gson = new Gson();
                sociList =
                        gson.fromJson( sociJSONStr, new TypeToken<ArrayList<Soci>>() {}.getType() );

            } catch (IllegalStateException e) {
                e.printStackTrace();
            }
        }

        return sociList;

    }
}
